#!/bin/sh

host=$1
url=$2
#echo host=$host url=$url

function get_file {
        echo "  == fetching firmware file $url/$1"
        /usr/local/bin/tftp $host > /dev/null <<EOF
        timeout 1
        get $url/$1
EOF
}                

cd /usr/conf

if [ -s firmware-update.conf ] ; then
        . firmware-update.conf                                                  
                                                                                
        if [ "$FIRMWARE_DOWNLOAD" = "yes" ] ; then    
                #echo "  ** Firmware Update Request, using '$FIRMWARE_FILE'"
                cd /mnt/images                   
                if ! [ -f /mnt/images/$FIRMWARE_FILE ] ; then
                        rm -rf *                                 
                        get_file $FIRMWARE_FILE
			if ! [ -s /mnt/images/$FIRMWARE_FILE ] ; then
	                  	echo "tftp_firmware_update:failed:Invalid_Firmware_File_'$FIRMWARE_FILE'"
	                    	exit 0
			fi                     
                else                                                            
                        echo "tftp_firmware_update:failed:Firmware_Image_already_exists"
			exit 0 
                fi                                                                
        	if [ "$FIRMWARE_INSTALL" = "yes" ] ; then                               
                	INSTALLED=$(cat /usr/local/FILENAME)                            

	                if [ "$INSTALLED" != "$FIRMWARE_FILE" ] ; then                  
        	            	/usr/local/sbin/install.sh $FIRMWARE_FILE
	                    	/usr/local/bin/beroconf set root app-image $FIRMWARE_FILE
				echo "tftp_firmware_update:success:Installed_'$FIRMWARE_FILE'"                     
                	else                                                            
                    	    if [ "$FIRMWARE_REINSTALL" = "yes" ] ; then 
	                            #echo "  ** re-installing '$FIRMWARE_FILE'" 
        	                    /usr/local/sbin/install.sh $FIRMWARE_FILE
                	    else
	                            echo "tftp_firmware_update:failed:Firmware_'$INSTALLED'_Already_Installed"    
        	            fi
                	fi                                                              
        	else
	                echo "tftp_firmware_update:failed:Install=No_Selected"    
	        fi 
	else
	        echo "tftp_firmware_update:failed:Download=No_Selected"    
	fi
else
      echo "tftp_firmware_update:failed:Missing_File_firmware-update.conf"    
fi
rm -f /usr/conf/firmware-update.conf
sync

